var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/defaultCode.ts
var defaultCode = {
  abap: `
* @highlight
REPORT Z_SAMPLE_REPORT.
REPORT Z_SAMPLE_REPORT.
*      ---------------
*           ^
*   [Hello World!]
`,
  "actionscript-3": `
package {
  // @highlight
  import flash.display.Sprite;

  public class CommentExample extends Sprite {
    public function CommentExample() {
  //       --------
  //           ^
  // [Hello World!]
    }
  }
}
`,
  ada: `
-- @highlight
with Ada.Text_IO;

procedure Comments_Example is
    -- This is a single-line comment
    --           -----------
    --              ^
    --  [Hello World!]
`,
  apache: `
# Virtual Host Configuration
<VirtualHost *:80>
    ServerName www.example.com
    DocumentRoot /var/www/html

    # This is a comment within a VirtualHost block.
    # It can provide additional information about the configuration of this specific virtual host.

    # Directory Configuration
    <Directory /var/www/html>
        Options FollowSymLinks
        AllowOverride None
        Require all granted
    </Directory>
</VirtualHost>
`,
  apex: `
public class ExampleClass {
  // @highlight
  public void doSomething() {
      System.debug('Doing something...');
    //       -----
    //         ^
    // [Hello World!]
  }
}
`,
  apl: `
\u235D @highlight
data \u2190 1 2 3 4 5

sum \u2190 +/data
\u235D     ------
\u235D       ^
\u235D  [Hello World!]

sum
`,
  applescript: `
-- @highlight
display dialog "Hello, World!"
--      ------
--         ^
-- [Hello World!]
`,
  ara: `
// @highlight
$foo = true;
$foo = true;
//     ----
//      ^
// [Hello!]
`,
  astro: `
---
import { Button } from 'Button'
---
<!-- @highlight -->
<div>Hello World!</div>
{/* ^ */}
{/*[Hello!] */}

<div>Hello World!</div>
<!-- ----------- -->
<!-- ^ -->
<!--[Hello!] -->
`,
  awk: `
# @highlight
sum = 0
sum = 1
#    --
#    ^
#[Hello!]
`,
  ballerina: `
//@highlight
import ballerina/io;

public function main() {
  string message = "Hello, Ballerina!";
  //     -------
  //       ^
  // [Hello!]
}
`,
  batch: `
echo Batch Script Example
REM  -----
REM ^
REM [Hello World!]
`,
  berry: `
# @highlight
def func(x)
  return x + 1.5
  #      -----
  #      ^
  #[Hello!]
end
`,
  //   bibtex: `
  // % @highlight
  // % Another reference
  // %    ^
  // % [Hello!]
  // `,
  bicep: `
// @highlight
// Define a storage
    // ----
// ^
//[Hello!]
`,
  blade: `
<h1>Welcome to our website!</h1>
{{--        ---- --}}
{{-- ^ --}}
{{-- [Hello World!] --}}
`,
  cadence: `
  // @highlight
fun add(a: Int, b: Int): Int {
  //---
  // ^
  //[Hello!]
  return a + b
}
`,
  clarity: `
;;   @highlight
;; This is a single-line comment 
;; ---
;; ^
;;[Hello!]
`,
  clojure: `
;   @highlight
; This is a single-line comment 
; ---
; ^
;[Hello!]
`,
  cmake: `
# @highlight
# This is a single-line comment
# ----
#  ^
#[Hello!]
  
`,
  asm: `
; @highlight
section .data
    message db 'Hello, World!', 0
;   -------
;     ^
; [Hello World!]
  
`,
  c: `
// @highlight
#include <stdio.h>

int main() {
    int x = 10;
//  -----------
//    ^
// [Hello World!]
    return 0;
}
`,
  cobol: `
* @highlight
ENVIRONMENT DIVISION.
DATA DIVISION.
*    --------
*   ^
* [Hello World!]
`,
  coffee: `
# @highlight
# coffee
#  ^
# [Hello!]
`,
  crystal: `
# @highlight
# coffee
  # ^
# [Hello!]
`,
  css: `
.a {
  /* hello */
/*    --- */
/*    ^  */
/*  [Hello!]  */
}
`,
  cue: `
// @highlight
// This is a configuration
//   -----
//    ^
// [Hello!]
`,
  d: `
// @highlight
// This is a configuration
//   -----
//    ^
// [Hello!]
`,
  dart: `
// @highlight
// This is a configuration
//   -----
//    ^
// [Hello!]
`,
  dax: `
// @highlight
// This is a configuration
//   -----
//    ^
// [Hello!]
`,
  dockerfile: `
# @highlight
FROM node:14
#---
  # ^
# [Hello!]
`,
  "dream-maker": `
// @highlight
// This is a configuration
//   -----
//    ^
// [Hello!] 
`,
  elixir: `
# @highlight
# coffee
# ------
  # ^
# [Hello!]
`,
  elm: `
-- @highlight
-- coffee
-- ------
  -- ^
-- [Hello!]
`,
  erb: `
<h1>Welcome to our website!</h1>
<%#            --- %>
<%#     ^ %>
<%# [Hello World!] %>
`,
  erlang: `
%%      @highlight
-export([add/2]).
%%      -------
%%      ^
%% [Hello World!]
`,
  fish: `
# @highlight
# coffee
# ------
  # ^
# [Hello!]
`,
  "f#": `
// @highlight
// coffee
// ------
  // ^
// [Hello!]
`,
  "git-commit": `
# @highlight
# coffee
# ------
# ^
# [Hello!]
`,
  glsl: `
// @highlight
// coffee
// ------
  // ^
// [Hello!]
`,
  gnuplot: `
# @highlight
# coffee
# ------
 # ^
# [Hello!]
`,
  graphql: `
# @highlight
type Query {
  #  -----
  #    ^
# [Hello world!]
}
`,
  groovy: `
// @highlight
// coffee
// ------
  // ^
// [Hello!]
`,
  hack: `
<?hh
// @highlight
    echo "hello";
//  ----
//   ^
// [Hello!]  
?>
`,
  haml: `
!!!
%html
  %head
    %title My HAML Page
-# @highlight
  %body
    %h1 Welcome to My HAML Page
    -#  -------
    -# ^
    -#[Hello World!]
`,
  handlebars: `
{{!-- @highlight --}}
<h1>{{pageTitle}}</h1>
{{!-- --------- --}}
{{!-- ^ --}}
{{!-- [Hello World!] --}}
`,
  haskell: `
-- @highlight
-- This is a single-line
--      ---
--      ^
-- [Hello World!]
`,
  hcl: `
# @highlight
# coffee
# ------
 # ^
# [Hello!]
  `,
  hlsl: `
// @highlight
// coffee
// ------
  // ^
// [Hello!]
  `,
  html: `
<!-- @highlight -->
<p>coffeee</p>   
<!-- ----- -->
<!--  ^ -->
<!-- [Hello ] -->
  `,
  cpp: `
// @highlight
#include <iostream>

int main() {
  int x = 10;
  //  -----------
  //    ^
  // [Hello World!]
  return 0;
}
`,
  "c#": `
// @highlight
using System;
namespace CommentExample
{
  // @highlight
  class Program
  {
    static void Main(string[] args)
    {
      int x = 10
    //----------
    // ^
    //[Hello World!]
    }

  }
}
`,
  go: `
// @highlight
package main
import "fmt"
func main() {
  variable := 10
//--------
//      ^
//[Hello World!]
}
`,
  java: `
// @highlight
public class CommentExample {
  public static void main(String[] args) {
    int x = 10;
//  ----------
//       ^
//[Hello world!]
    int square = x * x;
  }
}
`,
  javascript: `// @highlight
import { useState } from 'react';

//     (     ) (2     ) (   3 )
export default function Counter() {
  // @highlight
  const [count, setCount] = useState(0);
              //~~~~~~~~
  
  function handleClick() {
    setCount(count + 1);
  //-------------------
  //     ^
  //[Underline and callout!]
  }

  return (
    <button onClick={handleClick}>
    {/*       ^           */}
    {/* [Supports JSX] */}
    {/* [Awesome,right?] */}
      You pressed me {count} times
    </button>
  );
}`,
  imba: `
# @highlight
# coffee
# ------
 # ^
# [Hello!]
`,
  ini: `
; @highlight
[section1]
; coffee
; ------
; ^
; [Hello!]
`,
  properties: `
# @highlight
# coffee
# ------
  # ^
# [Hello!]
`,
  jison: `
// @highlight
// coffee
// ------
  // ^
// [Hello!]
`,
  json: `
{
  "name": "John",
  "age": 30,
  "isStudent": false
}
`,
  json5: `
{
  // This is a JSON5 object with comments
  "name": "John",
// @highlight
  "age": 30,
  "isStudent": false,
// ---------
// ^
//[Hello World!]
}
`,
  jsonc: `
{
  // This is a JSON5 object with comments
  "name": "John",
// @highlight
  "age": 30,
  "isStudent": false,
// ---------
// ^
//[Hello World!]
}
`,
  jsonnet: `
{
  // This is a JSON5 object with comments
  "name": "John",
// @highlight
  "age": 30,
  "isStudent": false,
// ---------
// ^
//[Hello World!]
}
`,
  jssm: `
// @highlight
// coffee
// ------
  // ^
// [Hello!]
`,
  jsx: `
function a() {
  // @highlight
  return <div>
  {/*    ----- */}
  {/*    ^ */}
  {/* [Hello World!] */}
  </div>
}
`,
  kotlin: `
// @highlight
fun main() {
  // This is a single-line comment
  println("Hello, World!")
  //     -----------------
  //      ^
  // [Hello World!]

}
`,
  kusto: `
// This is a single-line comment
// @highlight
let startDate = datetime(2023-01-01);
//  ---------
//    ^
// [Hello world!]
`,
  kql: `
// This is a single-line comment
// @highlight
print "Hello, world!";
//  ---------
//    ^
  // [Hello world!]
`,
  julia: `
# @highlight
variable = 1

variable = 10 
#          --
#          ^
# [Hello World]
`,
  matlab: `
% @highlight
% This is a single-line comment in MATLAB.

variable = 10; 
%          --
  %        ^
  % [Hello World!]
`,
  latex: `
% @highlight
documentclass{article}
%              -------
%                ^
%  [Hello       World!]
`,
  less: `

#lib() {
  .colors() {
    // @highlights
    @primary: blue;
    @secondary: green;
    /*          ----- */
    /*          ^ */
    /* [Hello World!] */

  }
}
`,
  liquid: `
This is a multi-line comment 
{% comment %}
          ----------
     ^
  [Hello World!]
{% endcomment %}
`,
  php: `
// @highlight
<?php
$variable = 10000;
//          --
//          ^
// [Hello world!]
// @highlight
?>
`,
  lisp: `
; @highlight
(defun calculate-square (x)
  "This function calculates the square of a number."
  ;     --------
  ;        ^
  ; [Hello World!]
  (* x x))
`,
  logo: `
; @highlight
REPEAT 4 [
  FORWARD 100 
; -------
;   ^
;[Hello World!]
  RIGHT 90 
]
`,
  lua: `
-- @highlight
print("Shaku!")
print("Hello, World!") -- This is a comment
--     ------------
--     ^
--    [Hello World!]

`,
  make: `
# Variables
# @highlight
CC = gcc
CFLAGS = -Wall -g
#        -----
#        ^
# [Hello World!]
`,
  makefile: `
# Variables
# @highlight
CC = gcc
CFLAGS = -Wall -g
#        -----
#        ^
# [Hello World!]
`,
  markdown: `
<!-- @highlight -->
# Markdown Comments
<!-- ---- -->
<!-- ^ -->
<!--[Hello]-->
`,
  marko: `
<!-- @highlight  -->
<div>Shaku Snippet!</div>
<!-- -----  -->
<!-- ^  -->
<!-- [Hello Shaku!]  -->

`,
  mdx: `
---
import { Button } from 'Button'
---

{/* @highlight */}
# Markdown Comments
<Alert></Alert>
{/* --- */}
{/* ^ */}
{/* [Hello!] */}

`,
  mermaid: `
graph LR
    A[Start] --> B[Process]
    %% @highlight
    B --> C[Process]
    C --> D[End]
    %%    -----
  %%      ^
  %% [Hello Shaku!]
`,
  nginx: `
# @highlight
server {
  listen 80;
  #      --
  #      ^
  # [Hello Shaku!]
  server_name example.com;
}
`,
  nim: `
# @highlight
proc add(a, b: int): int =
  return a + b
# ------
# ^
# [Hello Shaku!]
`,
  nix: `
{
  # @highlight
  option1 = "value1";
  #         --------
  #          ^
  # [Hello World!]
}
`,
  objc: `
#import <Foundation/Foundation.h>
// @highlight
// This is a single-line comment
// ------
//  ^
// [Hello World!]
`,
  ocaml: `
(* @highlight *)
let main () =
  print_string "Hello, OCaml!";
            (*  ----- *)
            (*  ^ *)
       (*  [Hello World!] *)

`,
  pascal: `
{ @highlight }
uses
  crt;
{ --- }
{ ^ }
{[This is a single-line comment]}
`,
  perl: `
# This is a single-line comment in Perl
# @highlight
print "Hello, World!";
#      -----
#       ^
# [Hello Shaku!]
`,
  powerquery: `
// @highlight
// This is a single-line comment
//           -----------
//              ^
//      [Hello World!]
`,
  powershell: `
# Variables
# @highlight
$age = 25
$name = "John"
#        ----
#         ^
# [Hello World!]
`,
  prisma: `
// @highlight
model User {
  // The user's username
  username  String   @unique
  //        ------
  //         ^
  // [Hello Shaku!]
}
`,
  prolog: `
% Predicates for family relationships
% @highlight
parent(john, sarah).
%     -----
%       ^
%  [Hello World!]

`,
  proto: `
// @highlight
syntax = "proto3";
//       --------
//        ^
// [Hello World!]

`,
  plsql: `
-- @highlight
DECLARE
  v_name VARCHAR2(50);
  --     --------
  --      ^
  --  [Hello Shaku!]
`,
  purescript: `
  -- You can also use comments to explain code
  -- @highlight
add :: Int -> Int -> Int
--     ---
--      ^
-- [Hello World!]
`,
  raku: `
# @highlight
my $variable = 42;  
#  ---------
#    ^
# [Hello World!]
`,
  perl6: `
# This is a single-line comment in Perl
# @highlight
print "Hello, World!";
#      -----
#       ^
# [Hello Shaku!]
`,
  razor: `
<h1>Welcome to our website!</h1>
  @{
    // ----
    // ^
    //[Hello World!]
  }
`,
  reg: `
; @highlight
"CompletionChar"=dword:00000040 
  ;    --------
  ;    ^
  ;[Hello World!]
`,
  rel: `
// @highlight
name: "John"; 
//    -----
//    ^
// [Hello Shaku!]
`,
  riscv: `
# @highlight
.data
  # Data section where
  value1: .word 10
# -----
# ^
#[Hello World!]
`,
  sas: `
/* This is a single-line comment */
/* @highlight */
data mydata;
  set inputdata;
/*    ---------- */
/*    ^ */
/* [Hello World] */
  `,
  sass: `
// Example Sass code with comments
// @highlight
$primary-color: #3498db;
//              -------
//              ^
//        [Hello Shaku!]
`,
  scala: `
// @highlight
object CommentsExample {
  def main(args: Array[String]): Unit = {
    //           -----
    //           ^
    // [Hello Shaku!]
  }
}
`,
  scheme: `
; This is a single-line comment in Scheme

(define (factorial n)
  ; Base case: factorial of 0 is 1
  ; @highlight
  (if (= n 0)
      1
      ; Recursive case: n * factorial of (n - 1)
      (* n (factorial (- n 1)))))
    ; ---------------------------
    ; ^
  ;[Hello Shaku!]
; @highlight start
(display "Factorial of 5 is: ")
(display (factorial 5)) ; Calculate and display factorial
(newline)
; @highlight end

`,
  shaderlab: `
Shader "Custom/ExampleShader" {
  Properties {
      _MainTex ("Texture", 2D) = "white" {}
      _Color ("Tint Color", Color) = (1, 1, 1, 1)
  }

  SubShader {
    // @highlight
      Tags { "RenderType"="Opaque" }
      // @highlight
      LOD 100

      Pass {
          CGPROGRAM
        //----------
        // ^
      //[Hello Shaku!]
          #pragma vertex vert
          // This is a single-line comment
      }
    }
  }
}
`,
  scss: `
/*    @highlight */
.button {
  background-color: $primary-color;
  color: white; 
  /*    ------ */
  /*    ^ */
  /* [Hello World!] */

}
`,
  shader: `
// @highlight start
// Input vertex position
attribute vec3 inPosition;
// @highlight end

// Output vertex position
varying vec4 outPosition;
//           ------------
//           ^
// [Hello World!]

`,
  shellscript: `
# Variable assignment
# @highlight
name="John"
#     ----
#      ^
# [Hello Shaku!]
`,
  bash: `
# Variable assignment
# @highlight
name="Alice"
#     ----
#      ^
# [Hello Shaku!]
`,
  shell: `
# Variable assignment
# @highlight
name="John"
#     ----
#      ^
# [Hello Shaku!]
`,
  zsh: `
# Variable assignment
# @highlight
name="John"
#     ----
#      ^
# [Hello Shaku!]
`,
  smalltalk: `
Object subclass: MyClass [
  "This is a simple class named MyClass."
  
  | instanceVariable |
  
  "@highlight"
  MyClass class >> classMethod [
      "This is a class method of MyClass."
      
      ^ 'Hello from class method!'
      "  -----"
      "  ^ "
  " [Hello Shaku!]"
  ]
  
  MyClass >> instanceMethod [
      "This is an instance method of MyClass."
      
      ^ 'Hello from instance method!'
  ]
]
`,
  solidity: `
// Function to add two numbers
// @highlight
function add(uint256 a, uint256 b) public pure returns (uint256) {
    // Adding the two numbers
    uint256 result = a + b;
  //--------------
  //      ^
  //[Hello World!]
}
`,
  r: `
# @highlight
# Variables
variable <- 123
#        --
#        ^
# [Hello World!]
`,
  sparql: `
# This is a SPARQL query that retrieves the names of all cities and their populations.

# @highlight
PREFIX dbo: <http://dbpedia.org/ontology/>
PREFIX dbp: <http://dbpedia.org/property/>
#           ---------
#           ^
# [Hello World!]
`,
  "ssh-config": `
# This is a comment 
Host myserver
    HostName 192.168.1.100
  # @highlight
    Port 22
    User myusername
    #    -----------
    #    ^
# [Hello Shaku!]
`,
  stata: `
* @highlight
use "mydata.dta"
*    ------
*     ^
* [Hello Shaku!]
`,
  stylus: `
body
  background-color: #f0f0f0
  // @highlight
  color: #333 
  //     ----
  //     ^
  // [Hello Shaku!]
`,
  svelte: `
 <script>
 // @highlight
  let count = 0;
//    ---------
//     ^
// [Hello Shaku!]
  // This is a single-line comment
</script>

<main>
  <!-- @highlight -->
  <h1>Hello Svelte!</h1>
<!--  ------------ -->
<!--  ^ -->
<!-- [Hello Shaku!] -->


  <p>The current count is {count}</p>
</main>

<style>
  /* This is a CSS comment */
  /* @highlight */
  main {
    text-align: center;
  /*            ------ */
  /*            ^ */
  /*     [Hello Shaku!] */

    padding: 2rem;
  }
</style>
 `,
  python: `
# @highlight
def greet(name):
    print(f"Hello, {name}!")
  # -----
  #   ^
  # [Hello world!]
`,
  ruby: `
# @highlight
square = variable * variable 
#        --------
#        ^
#   [Hello World!]
`,
  rust: `
// @highlight
fn main() {
  let square = variable * variable; 
  //           --------
  //              ^
  //      [Hello World!]
}
  `,
  sql: `
-- Create a new table to store customer information
CREATE TABLE Customers (
  -- @highlight
    CustomerID INT PRIMARY KEY,
    FirstName VARCHAR(50),
  --          -------
  --             ^
  --     [Hello World!]
    LastName VARCHAR(50)
);
`,
  "system-verilog": `
// @highlight start
module ExampleModule (
  input logic clk,
  //    -----
  input logic reset,
  output logic [7:0] data
);
// @highlight end
//  ^
//[Hello World!]
endmodule
`,
  tcl: `
# @highlight
set variable_name 42;
# Another comment explaining the above line
#         -------
#          ^
#   [Hello World!]
`,
  tex: `
documentclass{article}

% @highlight
begin{document}

This is some text in the document.
%       ---------
%       ^
% [Hello World!]
`,
  toml: `
# This is a TOML configuration file
# @highlight
title = "Example Config"
description = "An example of using comments in TOML"
#                 -------
#                 ^
#     [Hello Shaku!]

`,
  tsx: `
const MyComponent: React.FC = () => {
  return (
    {/* @highlight */}

    <div>
      {/* This is a comment inside JSX */}
      <h1>Hello, World!</h1>
      {/*        -----  */}
      {/*        ^  */}
      {/*   [Hello World!]  */}
    </div>
  );
};
`,
  turtle: `
import turtle

# @highlight start
# Create a Turtle screen
screen = turtle.Screen()
# @highlight end

# Set the background color of the screen
screen.bgcolor("white")
#      -------
#       ^
# [Hello World!]
`,
  swift: `
// @highlight
import Foundation

var variable = 10 
//           ----
//            ^
// [Hello world!]
`,
  twig: `
{# @highlight #}
{% if condition %}
  <p>The condition is true.</p>
  {# ------------- #}
  {#  ^ #}
  {# [Hello Shaku!] #}
{% else %}
`,
  typescript: `
// @highlight start
function add(a: number, b: number): number {
  return a + b;
}
// @highlight end


// Usage of the function
const result = add(5, 3); // result will be 8
//    ------
//      ^
// [Hello World!]
`,
  vb: `
Imports System
' @highlight
Namespace CommentExample
    Class Program
        ' @highlight
        Sub Main()
            highlight x As Integer = 10
        '   -----
        '    ^
        ' [Hello world!]
        End Sub
    End Class
End Namespace
`,
  verilog: `
// @highlight
module ExampleModule (
  input wire clk,       // Clock input
  input wire reset,     // Reset input
  output reg [7:0] data // Data output
//-----
  // ^
  //[Hello World!]
);

`,
  vhdl: `
-- This is a single-line comment in VHDL

-- @highlight
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
--  --------------
--   ^
-- [Hello Shaku!]

`,
  viml: `
" This is a single-line comment in VimL

" @highlight
let g:my_variable = 42 
"     -----------
"     ^
" [Hello World!]
`,
  vimscript: `
" This is a single-line comment in VimL

" @highlight
let g:my_variable = 42 
"     -----------
"     ^
" [Hello World!]
`,
  vue: `
<template>
  <div>
    <!-- @highlight -->
    <p>{{ message }}</p>
    <!--  ------- -->
    <!--  ^ -->
    <!-- [Hello Shaku!] -->
    <button @click="increment">Increment</button>
  </div>
</template>

<script>
export default {
  data() {
    return {
      message: "Hello, Vue!",
    // ------
    // ^
    // [Hello Shaku!]
      count: 0
    };
  },
  // @highlight start
  methods: {
    increment() {
      this.count++;
    
    }
  }
  // @highlight end

};
</script>
`,
  wasm: `
;; This is a single-line comment in WebAssembly
(module
  ;; @highlight start
  ;; This is a multi-line comment
  ;; that spans multiple lines
  ;; @highlight end

  (func $add (param $a i32) (param $b i32) (result i32)
    ;; This function adds two integers
    get_local $a
  ;;---------
  ;; ^
;;[Hello Shaku!]
    get_local $b
    i32.add
  )
)
`,
  wenyan: `
\u6CE8\u66F0\u3002@highlight start
\u543E\u6709\u4E00\u6578\u3002\u66F0\u4E94\u3002\u540D\u4E4B\u66F0\u300C\u9577\u300D\u3002\u6CE8\u66F0\u3002\u300C\u300C\u7BC0\u9EDE\u7684\u6578\u91CF\u300D\u300D\u3002
\u543E\u6709\u4E00\u5217\u3002\u540D\u4E4B\u66F0\u300C\u6A4B\u300D\u3002 \u6CE8\u66F0\u3002\u300C\u300C\u9130\u63A5\u6578\u7D44\u300D\u300D\u3002
\u6CE8\u66F0\u3002@highlight end

\u543E\u6709\u4E8C\u6578\u3002\u66F0\u4E00\u3002\u66F0\u4E94\u3002\u540D\u4E4B\u66F0\u300C\u958B\u59CB\u300D\u66F0\u300C\u7D42\u9EDE\u300D\u3002
\u6CE8\u66F0\u3002    --------
\u6CE8\u66F0\u3002    ^
\u6CE8\u66F0\u3002 [Hello Shaku!]

\u6CE8\u66F0\u3002\u76F8\u9130\u7BC0\u9EDE\u3002
`,
  wgsl: `
fn main() -> void {
  // Initialize variables
  var x: f32 = 5.0; // This is the value of x
  // @highlight start
  // Perform some calculations
  x = x * 2.0; // Double the value of x
  // @highlight end

  // Output the result
  log(x); // Log the value of x
  //      ------
  //      ^
  // [Hello Shaku!]
}
`,
  wolfram: `
(* Define a function that calculates the square of a number *)
square[x_] := x^2

(* @highlight start *)
(* Print a message *)
Print["This program calculates the square of a number."]
(*     ---- *)
(*     ^ *)
(*  [Hello Shaku!] *)


(* @highlight end *)

`,
  xml: `
<!-- @highlight -->
<!-- This is a comment inside the root element -->
<element1>
    <!-- Comment for element1 -->
    <subelement>Content</subelement>
    <!--        _______ -->
    <!--        ^ -->
    <!--     [Hello Shaku!] -->

</element1>
`,
  xsl: `
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <!-- This is a comment explaining the purpose of the XSLT stylesheet -->
  
  <!-- @highlight start -->
  <!-- Match any element and copy it to the output unchanged -->
  <xsl:template match="@*|node()">
    <xsl:copy>
      <xsl:apply-templates select="@*|node()"/>
    <!--   _______________ -->
    <!--        ^ -->
    <!--     [Hello Shaku!] -->
    </xsl:copy>
  </xsl:template>
  <!-- @highlight end -->


</xsl:stylesheet>
`,
  yaml: `
# Configuration settings for an application
# @highlight start
app_settings:
  name: MyApp
  version: 1.0
  # @highlight end

  # The following line is a comment about the description
  description: This is a sample application
  #            ----------------
  #            ^
  #    [Hello World!]

`,
  zenscript: `
// @highlight start
// Hello
// @highlight end

print("This line is commented out")
//     ----
//     ^
// [Hello Shaku!]
`
};
var supportedLangs = [
  "abap",
  "actionscript-3",
  "ada",
  "apache",
  "apex",
  "apl",
  "applescript",
  "ara",
  "asm",
  "astro",
  "awk",
  "ballerina",
  "bat",
  "batch",
  "berry",
  "be",
  // "bibtex",
  "bicep",
  "blade",
  "c",
  "cadence",
  // "cdc",
  "clarity",
  "clojure",
  // "clj",
  "cmake",
  "cobol",
  "codeql",
  // nothing to test
  // "ql",
  "coffee",
  "cpp",
  "crystal",
  "c#",
  "cs",
  "css",
  "cue",
  "d",
  "dart",
  "dax",
  "diff",
  // nothing to test
  "docker",
  "dockerfile",
  "dream-maker",
  "elixir",
  "elm",
  "erb",
  "erlang",
  "erl",
  "fish",
  "fsharp",
  "f#",
  "fs",
  // "gdresource",
  // "gdscript",
  // "gdshader",
  // "gherkin",
  "git-commit",
  // "git-rebase",
  "glsl",
  "gnuplot",
  "go",
  "graphql",
  "groovy",
  "hack",
  "haml",
  "handlebars",
  "hbs",
  "haskell",
  "hs",
  "hcl",
  "hlsl",
  "html",
  // "http",
  "imba",
  "ini",
  "properties",
  "java",
  "javascript",
  "js",
  // "jinja-html",
  "jison",
  "json",
  "json5",
  "jsonc",
  "jsonnet",
  "jssm",
  "fsl",
  "jsx",
  "julia",
  "kotlin",
  "kusto",
  "kql",
  "latex",
  "less",
  "liquid",
  "lisp",
  "logo",
  "lua",
  "make",
  "makefile",
  "markdown",
  "md",
  "marko",
  "matlab",
  "mdx",
  "mermaid",
  "nginx",
  "nim",
  "nix",
  "objective-c",
  "objc",
  "objective-cpp",
  "ocaml",
  "pascal",
  "perl",
  "php",
  "plsql",
  // "postcss",
  "powerquery",
  "powershell",
  "ps",
  // "ps1",
  "prisma",
  "prolog",
  "proto",
  // "pug",
  // "jade",
  // "puppet",
  "purescript",
  "python",
  "r",
  "raku",
  "perl6",
  "razor",
  "reg",
  "rel",
  "riscv",
  "rst",
  "ruby",
  "rb",
  "rust",
  "rs",
  "sas",
  "sass",
  "scala",
  "scheme",
  "scss",
  "shaderlab",
  "shader",
  "shellscript",
  "bash",
  // "console",
  "sh",
  "shell",
  "zsh",
  "smalltalk",
  "solidity",
  "sparql",
  "sql",
  "ssh-config",
  "stata",
  "stylus",
  "styl",
  "svelte",
  "swift",
  "system-verilog",
  // "tasl",
  "tcl",
  "tex",
  "toml",
  "tsx",
  "turtle",
  "twig",
  "typescript",
  "ts",
  // "v",
  "vb",
  // "cmd",
  "verilog",
  "vhdl",
  "viml",
  // "vim",
  "vimscript",
  // "vue-html",
  "vue",
  "wasm",
  "wenyan",
  // "文言",
  "wgsl",
  "wolfram",
  "xml",
  "xsl",
  "yaml",
  "yml",
  "zenscript"
];

// src/getHighlighters.ts
import { getHighlighter } from "shiki";

// src/codeToShakuHtml.ts
import {
  parseLine,
  renderComponent
} from "shaku-code-annotate-core";

// src/render.ts
var renderMarkStart = (id) => `<mark class="shaku-inline-highlight" ${id != null ? `data-id="${id}"` : ""}>`;
var MarkEnd = `</mark>`;
function renderInsertion(insertion) {
  if (insertion.type === "closing")
    return MarkEnd;
  return renderMarkStart(insertion.id);
}
function renderToken(token) {
  return `<span style="color: ${token.color}">${escapeHtml(
    token.content
  )}</span>`;
}
function renderSourceLineWithInlineHighlight(sourceLine, shakuLine) {
  const insertions = [];
  for (const part of shakuLine.line.config.parts) {
    insertions.push({
      position: shakuLine.offset + part.offset,
      type: "opening",
      id: part.id
    });
    insertions.push({
      position: shakuLine.offset + part.offset + part.length,
      type: "closing"
    });
  }
  let html = "";
  let currentPosition = 0;
  while (true) {
    const insertion = insertions.shift();
    const token = sourceLine.shift();
    if (insertion == null && token == null) {
      break;
    }
    if (insertion == null && token != null) {
      html += renderToken(token);
      currentPosition += token.content.length;
      continue;
    }
    if (token == null && insertion != null) {
      html += renderInsertion(insertion);
      continue;
    }
    if (token != null && insertion != null) {
      if (currentPosition === insertion.position) {
        html += renderInsertion(insertion);
        sourceLine.unshift(token);
      } else {
        if (currentPosition + token.content.length <= insertion.position) {
          html += renderToken(token);
          currentPosition += token.content.length;
          insertions.unshift(insertion);
        } else {
          const lengthToSlice = insertion.position - currentPosition;
          const head = token.content.slice(0, lengthToSlice);
          const tail = token.content.slice(lengthToSlice);
          sourceLine.unshift(__spreadProps(__spreadValues({}, token), {
            content: tail
          }));
          sourceLine.unshift(__spreadProps(__spreadValues({}, token), {
            content: head
          }));
          insertions.unshift(insertion);
        }
      }
    }
  }
  return html;
}
function renderSourceLine(sourceLine) {
  return sourceLine.map(
    (token) => `<span style="color: ${token.color}">${escapeHtml(
      token.content
    )}</span>`
  ).join("");
}
function escapeHtml(html) {
  return html.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&quot;").replace(/'/g, "&#039;");
}

// src/codeToShakuHtml.ts
var codeToShakuHtml = function({
  code,
  options
}) {
  var _a, _b, _c;
  const highlighter = this;
  let lang = (_a = options == null ? void 0 : options.lang) != null ? _a : "";
  lang = supportedLangs.includes(lang) ? lang : "";
  const theme = highlighter.getTheme();
  const isShakuSyntaxEnabled = (_b = options == null ? void 0 : options.isShakuSyntaxEnabled) != null ? _b : true;
  if (!isShakuSyntaxEnabled) {
    if (this.fallbackToShiki === false) {
      return {
        html: "",
        skipped: true
      };
    }
  }
  const lines = highlighter.codeToThemedTokens(code, lang);
  const foregroundColor = highlighter.getForegroundColor();
  const backgroundColor = highlighter.getBackgroundColor();
  const useDangerousRawHtml = options == null ? void 0 : options.useDangerousRawHtml;
  const markdownToHtmlAndSanitize = (_c = options == null ? void 0 : options.markdownToHtmlAndSanitize) != null ? _c : (md) => md;
  let html = `<pre class="shiki shaku ${theme.name}" style="color:${foregroundColor};background-color:${backgroundColor}">`;
  html += `<div class="code-container"><code>`;
  const parsedLines = parseLines(lines, lang, isShakuSyntaxEnabled);
  const hasFocus = hasShakuDirectiveFocus(parsedLines);
  let shouldHighlighNextSourceLine = false;
  let shouldDimNextSourceLine = false;
  let shouldFocusNextSourceLine = false;
  let isHighlightingBlock = false;
  let isDimBlock = false;
  let isFocusBlock = false;
  let shakuDirectiveHighlightInline = null;
  for (let i = 0; i < parsedLines.length; i++) {
    const line = parsedLines[i];
    const isShakuLine = line.type === "shaku" && !line.line.config.isEscaped;
    if (isShakuLine) {
      const shakuLine = line.line;
      switch (shakuLine.type) {
        case "DirectiveCallout": {
          const arrowOffset = shakuLine.config.offset;
          const directiveOffset = arrowOffset + line.offset;
          let minOffset = directiveOffset;
          const contents = [];
          let j = i + 1;
          while (j < parsedLines.length) {
            const nextLine = parsedLines[j];
            if (nextLine.type !== "shaku" || nextLine.line.type !== "AnnotationLine") {
              break;
            }
            minOffset = Math.min(
              minOffset,
              nextLine.line.config.offset + nextLine.offset
            );
            contents.push(
              markdownToHtmlAndSanitize(nextLine.line.config.content).trim()
              // String(
              //   unifiedProcessor.processSync(nextLine.line.config.content)
              // )
            );
            j += 1;
          }
          html += renderComponent(
            {
              type: "ShakuComponentCallout",
              config: {
                offset: minOffset,
                arrowOffset: directiveOffset - minOffset,
                contents: contents.join("")
              }
            },
            {
              useDangerousRawHtml
            }
          );
          i = j - 1;
          continue;
        }
        case "AnnotationLine":
          break;
        case "DirectiveCollapse":
          break;
        case "DirectiveHighlight": {
          const mark = shakuLine.config.mark;
          switch (mark) {
            case "start":
              isHighlightingBlock = true;
              break;
            case "end":
              isHighlightingBlock = false;
              break;
            case "below":
            default:
              shouldHighlighNextSourceLine = true;
              break;
          }
          break;
        }
        case "DirectiveDim": {
          const mark = shakuLine.config.mark;
          switch (mark) {
            case "start":
              isDimBlock = true;
              break;
            case "end":
              isDimBlock = false;
              break;
            case "below":
            default:
              shouldDimNextSourceLine = true;
              break;
          }
          break;
        }
        case "DirectiveFocus": {
          const mark = shakuLine.config.mark;
          switch (mark) {
            case "start":
              isFocusBlock = true;
              break;
            case "end":
              isFocusBlock = false;
              break;
            case "below":
            default:
              shouldFocusNextSourceLine = true;
              break;
          }
          break;
        }
        case "DirectiveUnderline": {
          const underlineOffset = shakuLine.config.offset;
          const underlineContent = shakuLine.config.content;
          const directiveOffset = underlineOffset + line.offset;
          let minOffset = directiveOffset;
          const contents = [];
          let j = i + 1;
          while (j < parsedLines.length) {
            const nextLine = parsedLines[j];
            if (nextLine.type !== "shaku" || nextLine.line.type !== "AnnotationLine") {
              break;
            }
            minOffset = Math.min(
              minOffset,
              nextLine.line.config.offset + nextLine.offset
            );
            contents.push(
              // some engines generates \n at line end
              markdownToHtmlAndSanitize(nextLine.line.config.content).trim()
              // String(
              //   unifiedProcessor.processSync(nextLine.line.config.content)
              // )
            );
            j += 1;
          }
          html += renderComponent(
            {
              type: "ShakuComponentUnderline",
              config: {
                offset: minOffset,
                underlineOffset: directiveOffset - minOffset,
                underlineContent,
                underlineStyle: shakuLine.config.style,
                contents: contents.join("")
              }
            },
            {
              useDangerousRawHtml
            }
          );
          i = j - 1;
          continue;
        }
        case "DirectiveHighlightInline": {
          if (parsedLines[i + 1].type === "default") {
            shakuDirectiveHighlightInline = {
              type: "shaku",
              line: shakuLine,
              offset: line.offset
            };
          }
          continue;
        }
        default:
          assertsNever(shakuLine);
      }
    } else {
      const shouldHighlight = isHighlightingBlock || shouldHighlighNextSourceLine;
      const shouldFocus = isFocusBlock || shouldFocusNextSourceLine;
      const shouldDim = isDimBlock || shouldDimNextSourceLine || hasFocus && !shouldFocus;
      shouldHighlighNextSourceLine = false;
      shouldFocusNextSourceLine = false;
      shouldDimNextSourceLine = false;
      const sourceLine = line.type === "default" ? line.line : line.sourceLine;
      const highlightClass = shouldHighlight ? " highlight" : "";
      const dimClass = shouldDim ? " dim" : "";
      const prefix = `<div class="line${highlightClass}${dimClass}">`;
      html += prefix;
      if (shakuDirectiveHighlightInline) {
        html += renderSourceLineWithInlineHighlight(
          sourceLine,
          shakuDirectiveHighlightInline
        );
        shakuDirectiveHighlightInline = null;
      } else {
        html += renderSourceLine(sourceLine);
      }
      html += `</div>`;
    }
  }
  html += `</code></div></pre>`;
  return {
    html,
    skipped: false
  };
};
function parseComment(line, lang) {
  var _a;
  if (line.length === 0)
    return null;
  const isCommentLine = line.every(
    (token) => {
      var _a2;
      return shouldBeTreatedAsWhitespace(token, lang) || ((_a2 = token.explanation) == null ? void 0 : _a2.some(
        (exp) => exp.scopes.some((scope) => {
          if (lang === "astro") {
            return scope.scopeName.startsWith("comment") && scope.scopeName !== "comment";
          }
          return scope.scopeName.startsWith("comment");
        })
      ));
    }
  );
  if (!isCommentLine)
    return null;
  const shouldTreatFirstTokenOffset = shouldBeTreatedAsWhitespace(
    line[0],
    lang
  );
  let offset = shouldTreatFirstTokenOffset ? line[0].content.length : 0;
  let body = "";
  if (lang != null && [
    "ada",
    "berry",
    "elm",
    "haml",
    "handlebars",
    "hlsl",
    "jssm",
    "kotlin",
    "nix",
    "ocaml",
    "prisma",
    "proto",
    "sas",
    "sass",
    "shaderlab",
    "shader",
    "solidity",
    "viml",
    "vimscript",
    "wenyan"
  ].includes(lang)) {
    body = line.slice(shouldTreatFirstTokenOffset ? 1 : 0).map((token) => token.content).join("");
  } else {
    const tokenWithBody = shouldTreatFirstTokenOffset ? line[1] : line[0];
    if (tokenWithBody != null) {
      const explanations = (_a = tokenWithBody.explanation) != null ? _a : [];
      for (let i = 0; i < explanations.length; i++) {
        const explanation = explanations[i];
        if (explanation.scopes.every(
          (scope) => !scope.scopeName.startsWith("punctuation.definition") && !isWhitespace(explanation.content)
        )) {
          body = explanation.content;
          break;
        }
        offset += explanation.content.length;
      }
    }
  }
  const { trimmedBody, offset: extraOffset } = trimCommentBody(body, lang);
  return {
    offset: offset + extraOffset,
    body: trimmedBody
  };
}
function parseLines(lines, lang, isShakuSyntaxEnabled) {
  return lines.map((line) => {
    if (isShakuSyntaxEnabled) {
      const parsedComment = parseComment(line, lang);
      if (parsedComment != null) {
        const { body, offset } = parsedComment;
        const shakuLine = parseLine(body);
        if (shakuLine != null) {
          if (shakuLine.config.isEscaped) {
            for (let i = line.length - 1; i >= 0; i--) {
              if (/!\s*$/.test(line[i].content)) {
                line[i].content = line[i].content.replace(/!(\s*)$/, "$1");
                break;
              }
            }
          }
          return {
            type: "shaku",
            line: shakuLine,
            sourceLine: line,
            offset
          };
        }
      }
    }
    return {
      type: "default",
      line
    };
  });
}
function hasShakuDirectiveFocus(lines) {
  return lines.some(
    (line) => line.type === "shaku" && line.line.type === "DirectiveFocus"
  );
}
function isWhitespace(str) {
  return /^\s+$/.test(str);
}
function shouldBeTreatedAsWhitespace(token, lang) {
  var _a;
  if (isWhitespace(token.content))
    return true;
  if (!["javascript", "jsx", "tsx", "astro", "mdx", "batch"].includes(lang != null ? lang : "")) {
    return false;
  }
  if ((_a = token.explanation) == null ? void 0 : _a.every((explanation) => {
    return isWhitespace(explanation.content) || explanation.scopes.some(
      (scope) => scope.scopeName.startsWith("meta.jsx.children")
    ) && explanation.scopes.some(
      (scope) => scope.scopeName.startsWith(
        "punctuation.section.embedded.begin"
      ) || scope.scopeName.startsWith("punctuation.section.embedded.end")
    ) || explanation.scopes.some(
      (scope) => scope.scopeName.startsWith("source.astro")
    ) && explanation.scopes.some(
      (scope) => scope.scopeName.startsWith(
        "punctuation.section.embedded.begin.astro"
      ) || scope.scopeName.startsWith(
        "punctuation.section.embedded.end.astro"
      )
    ) || explanation.scopes.some(
      (scope) => scope.scopeName === "keyword.command.rem.batchfile"
    ) || explanation.scopes.some((scope) => scope.scopeName === "source.mdx") && explanation.scopes.some(
      (scope) => scope.scopeName.startsWith("string.other.begin.expression.mdx")
    );
  })) {
    return true;
  }
  return false;
}
var commentMarkers = {
  abap: {
    head: /^\s*\*/
  },
  ada: {
    head: /^\s*\-\-/
  },
  apache: {
    head: /^\s*#/
  },
  "actionscript-3": {
    head: /^\s*\/\//
  },
  asm: {
    head: /^\s*;/
  },
  awk: {
    head: /^\s*#/
  },
  ballerina: {
    head: /^\s*\/\//
  },
  berry: {
    head: /^\s*#/
  },
  bicep: {
    head: /^\s*\/\//
  },
  clarity: {
    head: /^\s*;;/
  },
  cmake: {
    head: /^\s*#/
  },
  cobol: {
    head: /^\s*\*/
  },
  d: {
    head: /^\s*\/\//
  },
  elm: {
    head: /^\s*--/
  },
  dart: {
    head: /^\s*\/\//
  },
  erlang: {
    head: /^\s*%/
  },
  fsharp: {
    head: /^\s*\/\//
  },
  "f#": {
    head: /^\s*\/\//
  },
  "git-commit": {
    head: /^\s*#/
  },
  graphql: {
    head: /^\s*#/
  },
  haml: {
    head: /^\s*-#/
  },
  handlebars: {
    head: /^\s*\{\{!--/,
    tail: /--\}\}\s*$/
  },
  hlsl: {
    head: /^\s*\/\//
  },
  json5: {
    head: /^\s*\/\//
  },
  jsonnet: {
    head: /^\s*\/\//
  },
  jssm: {
    head: /^\s*\/\//
  },
  rust: {
    head: /^\s*\/\//
  },
  kotlin: {
    head: /^\s*\/\//
  },
  kusto: {
    head: /^\s*\/\//
  },
  kql: {
    head: /^\s*\/\//
  },
  mermaid: {
    head: /^\s*%%/
  },
  nginx: {
    head: /^\s*#/
  },
  nix: {
    head: /^\s*#/
  },
  ocaml: {
    head: /^\s*\(\*/,
    tail: /\s*\*\)$/
  },
  plsql: {
    head: /^\s*--/
  },
  powerquery: {
    head: /^\s*\/\//
  },
  prisma: {
    head: /^\s*\/\//
  },
  proto: {
    head: /^\s*\/\//
  },
  sas: {
    head: /^\s*\/\*/,
    tail: /\s*\*\/$/
  },
  sass: {
    head: /^\s*\/\//
  },
  shaderlab: {
    head: /^\s*\/\//
  },
  shader: {
    head: /^\s*\/\//
  },
  solidity: {
    head: /^\s*\/\//
  },
  sparql: {
    head: /^\s*#/
  },
  turtle: {
    head: /^\s*#/
  },
  vhdl: {
    head: /^\s*--/
  },
  viml: {
    head: /^\s*"/
  },
  vimscript: {
    head: /^\s*"/
  },
  wenyan: {
    head: /^\s*注曰。/
  },
  wgsl: {
    head: /^\s*\/\//
  },
  zenscript: {
    head: /^\s*\/\//
  }
};
function trimCommentBody(body, lang) {
  let trimmedBody = body;
  let offset = 0;
  if (lang != null && lang in commentMarkers) {
    const { head, tail } = commentMarkers[lang];
    if (head != null) {
      trimmedBody = trimmedBody.replace(head, "");
      offset = body.length - trimmedBody.length;
    }
    if (tail != null) {
      trimmedBody = trimmedBody.replace(tail, "");
    }
  }
  return {
    trimmedBody,
    offset
  };
}
function assertsNever(data) {
  throw new Error("expected never but got: " + data);
}

// src/getHighlighters.ts
var shikiHighlighterFetcherStore = /* @__PURE__ */ new Map();
function getShakuHighlighters(options) {
  return __async(this, null, function* () {
    var _a, _b;
    const key = JSON.stringify(options);
    if (shikiHighlighterFetcherStore.has(key)) {
      return shikiHighlighterFetcherStore.get(key);
    }
    const themes = (_b = options.themes) != null ? _b : [(_a = options.theme) != null ? _a : "github-light"];
    const highlighterFetcher = Promise.all(
      themes.map(
        (theme) => getHighlighter(__spreadProps(__spreadValues({}, options != null ? options : {}), {
          theme,
          themes: void 0
        })).then((highlighter) => {
          return Object.assign(highlighter, {
            codeToShakuHtml,
            fallbackToShiki: options.fallbackToShiki
          });
        })
      )
    );
    shikiHighlighterFetcherStore.set(key, highlighterFetcher);
    return highlighterFetcher;
  });
}
export {
  defaultCode,
  getShakuHighlighters,
  supportedLangs
};
